// Gravity Stomp Copyright Kevin Poretti

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "InputActionValue.h"
#include "GSCharacter.generated.h"


UCLASS(config=Game)
class AGSCharacter : public ACharacter
{
	GENERATED_BODY()

	/** MappingContext */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = Input, meta = (AllowPrivateAccess = "true"))
	class UInputMappingContext* DefaultMappingContext;

	/** Move Input Action */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = Input, meta = (AllowPrivateAccess = "true"))
	class UInputAction* MoveAction;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = Input, meta = (AllowPrivateAccess = "true"))
	class UInputAction* ChangeGravityAction;

public:
	AGSCharacter(const FObjectInitializer& ObjectInitializer = FObjectInitializer::Get());

	void ChangeTeamColor(bool bIsPlayerFriendly);

protected:

	/** Called for movement input */
	void Move(const FInputActionValue& Value);

	/** Called when the player changes the gravity direction */
	void ChangeGravityDirection(const FInputActionValue& Value);

public:
	virtual void PawnClientRestart() override;

protected:
	// APawn interface
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;
	
	// To add mapping context
	virtual void BeginPlay();
};

