// Gravity Stomp Copyright Kevin Poretti

#include "Player/GSPlayerController.h"

void AGSPlayerController::Client_GameStarted_Implementation()
{
    FInputModeGameOnly GameOnly;
    SetInputMode(GameOnly);
    SetIgnoreMoveInput(false);

    // enable all actions on pawn
    OnGameStarted();
}


void AGSPlayerController::Client_OnKill_Implementation(AGSPlayerState* KillerPlayerState,
    AGSPlayerState* VictimPlayerState)
{
    OnKill(KillerPlayerState, VictimPlayerState);
}


void AGSPlayerController::Client_OnDeath_Implementation(AGSPlayerState* KillerPlayerState,
    AGSPlayerState* VictimPlayerState)
{
    OnDeath(KillerPlayerState, VictimPlayerState);
}


void AGSPlayerController::Client_WarmupStarted_Implementation()
{
    OnWarmupStarted();
}

void AGSPlayerController::Client_GameRestarted_Implementation()
{
    OnGameRestarted();
}

void AGSPlayerController::ClientGameEnded_Implementation(AActor* EndGameFocus, bool bIsWinner)
{
    Super::ClientGameEnded_Implementation(EndGameFocus, bIsWinner);

    SetIgnoreMoveInput(true);

    APawn* MyPawn = GetPawn();
    if(MyPawn) // pawn may be null if we died and then the round ended
    {
        // disable all actions on character
        MyPawn->TurnOff();
    }

    OnGameEnded(bIsWinner);
}


void AGSPlayerController::UnFreeze()
{
    Super::UnFreeze();

    ServerRestartPlayer();
}


void AGSPlayerController::AcknowledgePossession(APawn* P)
{
    OnAcknowledgePossession();

    Super::AcknowledgePossession(P);
}